Require Import Coq.Lists.List.
Import ListNotations.
Require Import ProgramCalculation.theories.Algebra.Algebra.
Require Import ProgramCalculation.library.Notations.
Require Import ProgramCalculation.theories.Lists.Notations.
Require Import ProgramCalculation.library.Tactics.
Generalizable All Variables.

(** * Join-list induction principle *)

Lemma join_ind:
  forall(A:Type)(P:list A->Prop),
    (P []) ->
    (forall a, P [a]) -> 
    (forall x y, P x -> P y -> P (x ++ y)) -> 
    forall l, P l.
Proof.
  intros A P Hnil Hone Hjoin l.
  induction l as [ | a l IH ].
  - assumption.
  - change (a::l) with ([a]++l).
    now apply Hjoin.
Qed.

(** * Snoc-list induction principle *)
Definition snoc_ind := rev_ind.